// transfer NPC_ from Morroblivion to Skywind

unit UserScript;

var
  fname: string;
  sl, slv: TStringList;

//============================================================================
procedure ImportData;
var
  skywind: IInterface;
  baserecord, r: IInterface;
  i: integer;
  race, formid: Cardinal;
  IsFemale: boolean;
begin
  skywind := FileByIndex(FileCount - 1);
  if not SameText(GetFileName(skywind), 'skywind.esp') then begin
    AddMessage('Skywind.esp must be loaded last');
    Result := 1;
    Exit;
  end;

  sl.LoadFromFile(fname);
  
  for i := 0 to sl.Count - 1 do begin
    slv.DelimitedText := sl[i];
    
    if (StrToInt('$' + slv[3]) and 1) > 0 then IsFemale := true else IsFemale := false;
    race := StrToInt('$' + slv[4]);
    
    // oblivion races
    // DarkElf "Dark Elf" [RACE:000191C1]
    // WoodElf "Wood Elf" [RACE:000223C8]
    // HighElf "High Elf" [RACE:00019204]
    // Breton "Breton" [RACE:000224FC]
    // Imperial "Imperial" [RACE:00000907]
    // Nord "Nord" [RACE:000224FD]
    // Redguard "Redguard" [RACE:00000D43]
    // Orc "Orc" [RACE:000191C0]
    // Khajiit "Khajiit" [RACE:000223C7]
    // Argonian "Argonian" [RACE:00023FE9]
    
    // ArgonianFemalePreset01 [NPC_:000B2E11]
    // ArgonianMalePreset01 [NPC_:00043E57]
    if race = $00023FE9 then begin
      if IsFemale then formid := $000B2E11 else formid := $00043E57;
    end else
    // BretonFemalePreset01 "Prisoner" [NPC_:00079F65]
    // BretonMalePreset01 "Prisoner" [NPC_:00079F6A]
    if race = $000224FC then begin
      if IsFemale then formid := $00079F65 else formid := $00079F6A;
    end else
    // HighElfFemalePreset01 "Prisoner" [NPC_:00079BED]
    // HighElfMalePreset01 "Prisoner" [NPC_:0005EF9C]
    if race = $00019204 then begin
      if IsFemale then formid := $00079BED else formid := $0005EF9C;
    end else
    // ImperialFemalePreset01 "Prisoner" [NPC_:00079F66]
    // ImperialMalePreset01 "Prisoner" [NPC_:00026921]
    if race = $00000907 then begin
      if IsFemale then formid := $00079F66 else formid := $00026921;
    end else
    // KhajiitFemalePreset01 [NPC_:000EE856]
    // KhajiitMalePreset01 [NPC_:00043E59]
    if race = $000223C7 then begin
      if IsFemale then formid := $000EE856 else formid := $00043E59;
    end else
    // NordFemalePreset01 "Prisoner" [NPC_:00079F68]
    // NordMalePreset01 "Prisoner" [NPC_:0001750C]
    if race = $000224FD then begin
      if IsFemale then formid := $00079F68 else formid := $0001750C;
    end else
    // OrcFemalePreset01 "Prisoner" [NPC_:00079F4E]
    // OrcMalePreset01 "Prisoner" [NPC_:00079F69]
    if race = $000191C0 then begin
      if IsFemale then formid := $00079F4E else formid := $00079F69;
    end else
    // RedguardFemalePreset01 "Prisoner" [NPC_:00079F67]
    // RedguardMalePreset01 "Prisoner" [NPC_:0005B4F8]
    if race = $00000D43 then begin
      if IsFemale then formid := $00079F67 else formid := $0005B4F8;
    end else
    // WoodElfFemalePreset01 "Prisoner" [NPC_:00079CD3]
    // WoodElfMalePreset01 "Prisoner" [NPC_:0005EF9A]
    if race = $000223C8 then begin
      if IsFemale then formid := $00079CD3 else formid := $0005EF9A;
    end else
    // anyone else is a dunmer
    // DarkElfFemalePreset01 "Prisoner" [NPC_:00079F5B]
    // DarkElfMalePreset01 "Prisoner" [NPC_:0005EFA7]
    if IsFemale then formid := $00079F5B else formid := $0005EFA7;
    
    baserecord := RecordByFormID(FileByIndex(0), formid, True);
    if not Assigned(baserecord) then begin
      AddMessage('Can not find base record ' + IntToHex(formid, 8));
      Result := 1;
      Exit;
    end;
   
    // copy base record as new
    r := wbCopyElementToFile(baserecord, skywind, True, True);
    if not Assigned(r) then begin
      AddMessage('Unable to copy base record as new');
      Exit;
    end;

    SetLoadOrderFormID(r, StrToInt('$' + slv[0]));
    SetElementEditValues(r, 'EDID', slv[1]);
    SetElementEditValues(r, 'FULL', slv[2]);
  end;
end;  

//============================================================================
function Initialize: integer;
begin
  fname := ProgramPath + 'Edit Scripts\Skywind NPC_.txt';
  sl := TStringList.Create;
  slv := TStringList.Create;
  slv.Delimiter := ';';
  slv.StrictDelimiter := true;

  // import
  if wbGameMode = gmTES5 then begin
    ImportData;
  end;
end;

//============================================================================
function Process(e: IInterface): integer;
var
  line: string;
begin
  if wbGameMode <> gmTES4 then begin
    Result := 1;
    Exit;
  end;

  if Signature(e) <> 'NPC_' then
    Exit;

  line := Format('%s;%s;%s;%s;%s', [
    IntToHex64(GetLoadOrderFormID(e), 8),
    GetElementEditValues(e, 'EDID'),
    GetElementEditValues(e, 'FULL'),
    IntToHex64(GetElementNativeValues(e, 'ACBS\Flags'), 8),
    IntToHex64(GetElementNativeValues(e, 'RNAM'), 8)
  ]);
  sl.Add(line);
   
end;

//============================================================================
function Finalize: integer;
begin
  if wbGameMode = gmTES4 then begin
    AddMessage('Saving ' + fname);
    sl.SaveToFile(fname);
  end;
  sl.Free;
  slv.Free;
end;

end.
